package Data::MemInfo;

###----------------------------------------------------------------###
#  Copyright 2003 - Paul Seamons                                     #
#  Distributed under the GNU General Public License without warranty #
###----------------------------------------------------------------###

use strict;
use Exporter;
@Data::MemInfo::ISA       = qw(Exporter);
@Data::MemInfo::EXPORT    = qw(mem_info mem_info_statm mem_info_stat);
@Data::MemInfo::EXPORT_Ok = qw(mem_info mem_info_statm mem_info_stat);

sub mem_info {
  my $pid = (! $_[0]) ? $$ : ($_[0] =~ /\D/) ? die : shift();
  return {} if ! open(IN,"</proc/$pid/statm");
  my @info = split /\s+/, scalar <IN>;
  close IN;
  return {
    size     => $info[0] * 4,
    resident => $info[1] * 4,
    shared   => $info[2] * 4,
  };
}

sub mem_info_statm {
  &mem_info;
}

sub mem_info_stat {
  my $pid = (! $_[0]) ? $$ : ($_[0] =~ /\D/) ? die : shift();
  return {} if ! open(IN,"</proc/$pid/statm");
  my @info = split /\s+/, scalar <IN>;
  close IN;
  return {
    pid      => $info[0],
    ppid     => $info[3],
    utime    => $info[13] / 100,
    stime    => $info[14] / 100,
    cutime   => $info[15] / 100,
    cstime   => $info[16] / 100,
    vsize    => $info[22],
    rss      => $info[23] * 4,
    priority => $info[18],
  };
}

1;
