package PerlCAD::Command;

register_action({
  name      => 'toolsscript',
  accel     => 'Alt+S',
  menutext  => 'Run &Script',
  tooltip   => 'Run a script containing perlcad commands',
  whatsthis => '',
  slot      => 'toolsscript_slot',
  method    => sub {
    this->slot_process_line("SCRIPT");
  },
});

register_command({
  command => 'SCRIPT',
  requires => [{ type => 'FILENAME', msg => 'Specify filename of script to run' }],
  method => sub {
    my $state = shift;
    my $file  = shift;
    run_script($file);
  },
});


use vars qw($SCRIPTS_N);
register_action({
  name      => 'toolsloadscripts',
  menutext  => '&Load Scripts',
  tooltip   => 'Parse directories for scripts to run',
  whatsthis => '',
  slot      => 'toolsloadscripts_slot',
  method    => sub {
    if (__FILE__ =~ /^(.+)\/(blib|lib)\//) {
      my @dirs = ("$1/sample/scripts");
      require File::Find;
      &File::Find::find(sub {
        return if ! -x;
        return if ! -T;
        $SCRIPTS_N ||= 0;
        $SCRIPTS_N ++;
        my $name = "toolsscript${SCRIPTS_N}";
        my $file = $File::Find::name;
        register_action({
          name     => $name,
          menutext => "&$SCRIPTS_N - $_",
          tooltip  => '',
          slot     => "slot_${name}",
          method   => sub { this->slot_process_line("SCRIPT $file") },
        });
        get_action($name)->addTo(this->parent->scripts_menu);
      }, @dirs);
    }
  },
});
