package PerlCAD::Command;

###----------------------------------------------------------------###
#  Copyright 2003 - Paul Seamons                                     #
#  Distributed under the GNU General Public License without warranty #
###----------------------------------------------------------------###

use strict;
use Data::DumpEx;

###----------------------------------------------------------------###

register_action({
  name      => 'eraser',
  accel     => 'Ctrl+D',
  menutext  => '&Erase',
  tooltip   => 'Erase Items',
  whatsthis => '<img src="eraser"> <b>Erase</b><br/>Select items to erase',
  slot      => 'modify_erase_slot',
  method    => sub {
    this->slot_process_line('ERASE');
  },
});

register_command({
  command => 'ERASE',
  aliases => ['E', 'DELETE', 'DEL'],
  method  => \&modify_erase,
  requires => [
    { type => 'SELECTION', msg => 'Select an items to erase (ENTER to erase)', },
  ],
});

###----------------------------------------------------------------###

sub modify_erase {
  my $info = shift;
  my $list = shift;
  dex $list;
}

1;
