package PerlCAD::Item::LastPoint;

###----------------------------------------------------------------###
#  Copyright 2003 - Paul Seamons                                     #
#  Distributed under the GNU General Public License without warranty #
###----------------------------------------------------------------###

use strict;
use Qt;
use Qt::isa qw(Qt::CanvasPolygonalItem);
use Qt::attributes qw(
                      point
                      dia
                      color
                      );
use Data::DumpEx;

sub NEW {
  my $class  = shift;
  my $canvas = shift;
  $class->SUPER::NEW($canvas);
  dia   = 4;
  color = Qt::Pen(Qt::yellow());
  point = shift || Qt::Point(0,0);
}

sub DESTROY {
  hide();
}

sub setPoint {
  point = shift;
  update();
}

sub rtti {
  1003;
}

sub drawShape {
  my $painter = shift;
  $painter->setPen(color);
  $painter->drawLine(point->x - dia, point->y, point->x + dia, point->y);
  $painter->drawLine(point->x, point->y - dia, point->x, point->y + dia);
#  $painter->setClipRegion(Qt::Region(points));
#  $painter->fillRect(points->boundingRect, brush());
}

sub areaPoints {
  my $array = Qt::PointArray(4);
  $array->setPoint(0, point->x - dia - 1, point->y - dia - 1);
  $array->setPoint(1, point->x - dia - 1, point->y + dia - 1);
  $array->setPoint(2, point->x + dia - 1, point->y + dia - 1);
  $array->setPoint(3, point->x + dia - 1, point->y - dia - 1);
  return $array;
}

sub boundingRect {
  return Qt::Rect(point->x - dia, point->y - dia, dia * 2 + 1, dia * 2 + 1);
}

1;
