package PerlCAD::UI::LayerCombo;


use strict;
use Qt;
use Qt::isa qw(Qt::ComboBox);
use Qt::attributes qw(
                      mainwindow
                      layername
                      layer_id
                      ltype
                      color
                      width
                      hidden
                      locked
                      );
use Qt::signals
  clicked => [],
  ;

use Data::DumpEx;

sub NEW {
  my $class  = shift;
  my $parent = shift;
  my $name   = shift;
  my $window = shift;
  $class->SUPER::NEW($parent, $name);

  mainwindow = $window;
  insertItem(Qt::Pixmap(35,11),"default", 0);
}

sub set_layername {
  my $layer = layername = shift;
  my $info = mainwindow->doc->query_layer($layer);
  my ($id, $ltype, $color, $width, $hidden, $locked) = @$info;
  layer_id = $id;
  ltype    = $ltype  || $PerlCAD::DB::DEFAULT_LTYPE;
  color    = $color  || $PerlCAD::DB::DEFAULT_COLOR;
  width    = $width  || 0;
  hidden   = $hidden || 0;
  locked   = $locked || 0;

  my $pix = Qt::Pixmap(35,11);
  my $col = Qt::Color();
  $col->setNamedColor($color);
  $pix->fill($col);
  
  changeItem($pix, layername, 0);
  setCurrentItem(0);

  ### allow for setting color
  my $_color = mainwindow->prop_color->colorname;
  if (! defined($_color) || lc($_color) eq 'bylayer') {
    mainwindow->prop_color->set_colorname($_color || 'ByLayer');
  }
}

sub mousePressEvent {
  my $event = shift;
  if ($event->button == Qt::RightButton()) {
    SUPER->mousePressEvent($event);
    return;
  }
  emit clicked;
}

1;
